package com.example.demo.controller;

import org.apache.rocketmq.client.producer.SendCallback;
import org.apache.rocketmq.remoting.common.RemotingHelper;
import org.joda.time.DateTime;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.apache.rocketmq.client.consumer.DefaultMQPushConsumer;
import org.apache.rocketmq.client.consumer.listener.ConsumeConcurrentlyContext;
import org.apache.rocketmq.client.consumer.listener.ConsumeConcurrentlyStatus;
import org.apache.rocketmq.client.consumer.listener.MessageListenerConcurrently;
import org.apache.rocketmq.client.producer.DefaultMQProducer;
import org.apache.rocketmq.client.producer.SendResult;
import org.apache.rocketmq.common.consumer.ConsumeFromWhere;
import org.apache.rocketmq.common.message.Message;
import org.apache.rocketmq.common.message.MessageExt;
import java.util.List;
import java.util.concurrent.Semaphore;

import static com.example.demo.controller.Reliability.*;


@RestController
public class HelloController {
    /**
     * http://localhost:8080/hello
     * @return
     */
    @RequestMapping("/hello")
    public String index() {
        return "Hello World";
    }
    private static int count = 100;
    /**
     * http://localhost:8080/send
     * http://122.112.203.214:8888/send
     *  发送MQ 消息
     * @return
     */
    @RequestMapping("/send")
    public void send(){
        // 设置生产者组名
        DefaultMQProducer producer = new DefaultMQProducer("Producer");
        // 指定nameServer的地址
        producer.setNamesrvAddr("172.16.11.248:8100");
//        producer.setNamesrvAddr("172.16.11.248:8100;172.16.10.101:8100");
        try {
            // 启动实例
            producer.start();
            String str = "1 Just for test.";
            Message msg = new Message("miyapaytest",
                    "push",
                    "1",
                    str.getBytes());

            SendResult result = producer.send(msg);
            System.out.println("id:" + result.getMsgId() + "msg:" + str +
                    " result:" + result.getSendStatus());

//            msg = new Message("miyapaytest",
//                    "push",
//                    "2",
//                    "2 Just for test.".getBytes());
//
//            result = producer.send(msg);
//            System.out.println("id:" + result.getMsgId() +
//                    " result:" + result.getSendStatus());
//
//            msg = new Message("miyapaytest",
//                    "push",
//                    "1",
//                    "3 Just for test.".getBytes());

            result = producer.send(msg);
            System.out.println("id:" + result.getMsgId() + "  " + result.getMessageQueue().toString() +
                    " result:" + result.getSendStatus());
//            final Semaphore semaphore = new Semaphore(0);
//            for (int i = 0; i < count; i++) {
//                Thread.sleep(3000);
//                Message message = new Message("miyapaytest",
//                        "test_tag",
//                        ("Hello RocketMQ " + i).getBytes(RemotingHelper.DEFAULT_CHARSET));
//
//                producer.send(message, new SendCallback() {
//                    public void onSuccess(SendResult sendResult) {
//                        System.out.println(String.format("message [%s] send success!", new String(message.getBody())));
//                        semaphore.release();
//                    }
//
//                    public void onException(Throwable throwable) {
//                        throwable.printStackTrace();
//                    }
//                });
//
//            }
//            semaphore.acquire(count);
        } catch (Exception e) {
            e.printStackTrace();
        }finally{
            //关闭生产者，释放资源
            producer.shutdown();
        }

    }

    /**
     * http://localhost:8080/consumer3
     * http://122.112.203.214:8888/consumer3
     * 消费消息
     * @return
     * Consumer类，消费者，接受处理消息
     */
    @RequestMapping("/consumer3")
    public String consumer3(){
        //设置消费者组名
        DefaultMQPushConsumer consumer =
                new DefaultMQPushConsumer("miyapaytest_consumer");
        //指定nameServer的地址
        consumer.setNamesrvAddr("172.16.11.248:8100");
        try {
            //订阅PushTopic下Tag为push的消息  //指定订阅的topic及tag表达式
//            consumer.subscribe("miyapaytest", "push");
//            consumer.subscribe("miyapaytest", "*");
            consumer.subscribe("miyapaytest", "push");

            //程序第一次启动从消息队列头取数据
            consumer.setConsumeFromWhere(
                    ConsumeFromWhere.CONSUME_FROM_FIRST_OFFSET);

            consumer.registerMessageListener(new MessageListenerConcurrently() {
                                                 public ConsumeConcurrentlyStatus consumeMessage(List<MessageExt> list, ConsumeConcurrentlyContext Context) {
                                                     Message msg = list.get(0);
//                            System.out.println(msg.toString());

                                                     String topic = msg.getTopic();
//                                                     System.out.println("topic = " + topic);
                                                     byte[] body = msg.getBody();
//                                                     System.out.println("body:  " + new String(body));
                                                     String keys = msg.getKeys();
//                                                     System.out.println("keys = " + keys);
                                                     String tags = msg.getTags();
//                                                     System.out.println("tags = " + tags);
                                                     System.out.println("topic = " + topic +"body:  " + new String(body) + "keys = " + keys
                                                     +"tags = " + tags + new DateTime().toString("yyyy-MM-dd HH:mm:ss"));
                                                     System.out.println("-----------------------------------------------" + new DateTime().toString("yyyy-MM-dd HH:mm:ss"));

//                                                     return ConsumeConcurrentlyStatus.CONSUME_SUCCESS;
                                                     return ConsumeConcurrentlyStatus.RECONSUME_LATER;
                                                 }
                                             }
            );
            //启动消费者实例
            consumer.start();
            System.out.println("Consumer Started.");
        } catch (Exception e) {
            e.printStackTrace();
        }
        return "ok";
    }

    /**
     * https://my.oschina.net/buru1kan/blog/1806173
     *
     */
    @RequestMapping("/consumer2")
    public void consumer2(){

       try {
           //设置消费者组名
           DefaultMQPushConsumer consumer = new DefaultMQPushConsumer("ConsumerGroupName");
           //设置Consumer第一次启动是从队列头部开始消费还是队列尾部开始消费<br>
           consumer.setConsumeFromWhere(ConsumeFromWhere.CONSUME_FROM_FIRST_OFFSET);
           //指定nameServer的地址
           consumer.setNamesrvAddr("172.16.11.248:8100");
           //指定订阅的topic及tag表达式
//           consumer.subscribe("miyapaytest", "*");

           consumer.subscribe("miyapaytest_consumer", "*");

           consumer.registerMessageListener(new MessageListenerConcurrently() {
               public ConsumeConcurrentlyStatus consumeMessage(List<MessageExt> msgs,
                                                               ConsumeConcurrentlyContext context) {
                   MessageExt messageExt = msgs.get(0);
                   System.out.println(String.format("Custome message [%s],tagName[%s]",
                           new String(messageExt.getBody()),
                           messageExt.getTags()));
                   return ConsumeConcurrentlyStatus.CONSUME_SUCCESS;
               }
           });
           //启动消费者实例
           consumer.start();
           System.out.println("Consumer Started.");
       }catch (Exception e){
           e.printStackTrace();
       }
    }

    /**
     * http://localhost:8080/produce
     *  http://122.112.203.214:8888/produce
     */
    @RequestMapping("/produce")
    public String test1(){
        try {
            produce();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return "ok";
    }

    /**
     * http://localhost:8080/consume
     * http://122.112.203.214:8888/consume
     */
    @RequestMapping("/consume")
    public String test2(){
        try {
            consume();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return "ok";
    }

    /**
     * http://122.112.203.214:8888/PullConsumer
     */
    @RequestMapping("/PullConsumer")
    public String PullConsumer1(){
        try {
            PullConsumer();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return "ok";
    }

}