/*
 * Miya.com Inc.
 * Copyright (c) 2004-2018 All Rights Reserved.
 */
package com.example.demo.mq;

import lombok.extern.slf4j.Slf4j;
import org.apache.rocketmq.client.producer.DefaultMQProducer;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;


@Slf4j
@Configuration
public class ProducerConfiguration {
    /**
     * 一个应用只配置一个
     * @return
     */
    @Qualifier(value = "ledgerProducer")
    @Bean(initMethod = "start", destroyMethod = "shutdown")
    DefaultMQProducer ledgerProducer() {
        DefaultMQProducer producer = new DefaultMQProducer("Producer");
        producer.setNamesrvAddr("172.16.10.101:8100");
        log.info("生产这启动成功");
        return producer;
    }

}