
package com.example.demo.mq.producer;

import lombok.extern.slf4j.Slf4j;
import org.apache.rocketmq.client.exception.MQClientException;
import org.apache.rocketmq.client.producer.DefaultMQProducer;
import org.apache.rocketmq.client.producer.SendResult;
import org.apache.rocketmq.common.message.Message;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.UUID;

@Slf4j
@Component
public class LedgerMQProducer {

    @Resource
    private DefaultMQProducer ledgerProducer;
    @Async
    public String sendMessage(String message, int level) throws MQClientException {
//        DefaultMQProducer ledgerProducer = new DefaultMQProducer("Producer_mm");
//        ledgerProducer.setNamesrvAddr("172.16.10.101:8100");
//        ledgerProducer.start();
        Message msg = new Message(
                "miyapaytest",
                "tag",
                UUID.randomUUID().toString(),
                message.getBytes());
        msg.setDelayTimeLevel(level);
        try {
            SendResult sendResult = ledgerProducer.send(msg);
            assert sendResult != null;
            log.info("发送分账消息成功：" + sendResult.getMsgId());
            return sendResult.getMsgId();
        } catch (Exception e) {
            e.printStackTrace();
        }
//        finally {
//            ledgerProducer.shutdown();
//        }

        return "";
    }

    @Async
    public String sendMessage1(String message) throws MQClientException {
//        DefaultMQProducer ledgerProducer = new DefaultMQProducer("Producer_mm");
//        ledgerProducer.setNamesrvAddr("172.16.10.101:8100");
//        ledgerProducer.start();
        Message msg = new Message(
                "miyapaytest",
                "tag1",
                UUID.randomUUID().toString(),
                message.getBytes());
        try {
            SendResult sendResult = ledgerProducer.send(msg);
            assert sendResult != null;
            log.info("发送分账消息成功：" + sendResult.getMsgId());
            return sendResult.getMsgId();
        } catch (Exception e) {
            e.printStackTrace();
        }
//        finally {
//            ledgerProducer.shutdown();
//        }

        return "";
    }
}